#!/usr/bin/perl

#
# LB300d_R1.0 Release
# 
# Bug Fix Number : 28,65
# 060927  /etc/hosts config by maruo 
#

#
# 饤֥ɤ߹
#
require "/opt/nec/wbmc/lib/wbmc.pl";
require "/tmp/config_ReadFile.pl";

#
# ѿؤν
#

# եѥ
my($hosts_filename) = "/etc/hosts";

# ХååפݤΥե̾
my($hosts_backup) = "hosts.org";

# ¾ ץǻѤѥ
my($ifcfg_dir) = "/etc/sysconfig/network-scripts";

# line : եɤ߹ݤˤƤǼ
local(@line1) = ();	# /etc/hosts

# line_tmp : ŪʸǼ˻
local(@line_tmp) = ();

# file : ե˽񤭹ƤǼ
local(@file1) = ();	# /etc/hosts

# IPɥ쥹eth0-2Ǽ
my(@ipaddr) = ();

# Ƽѿ
my(	$i,				# Ū˻
	$vad_flag,			# vadѤƤ뤫Ǽե饰
	$hostname,$shorthostname,	# FQDN,ۥ̾FQDNκǽΥ٥ʬ
	$err,				# 顼å
	$ipaddr_vad,$ipaddr_lo,		# IPɥ쥹vad,loǼ
	$backup_dir			# ѥååΥǥ쥯ȥѥǼ	
	) = "";

#
# оݤΥեХåå
#

# ХååΥǥ쥯ȥ
$backup_dir = `/bin/date '+%Y%m%d%H%M%S'`;
chomp $backup_dir;  #ԥɤκ
$backup_dir = "/tmp/backup_${backup_dir}_ho";
system("/bin/mkdir $backup_dir");

# Хåå
system("/bin/cp -fp $hosts_filename ${backup_dir}/${hosts_backup}");

#
# ӻоݤΥեɤ߹
#
# /etc/hostsɤ߹
# ǥ桼ꤷƤԤФǻѤ
if(!&configReadFile($hosts_filename,"hosts",*line1)){
	exit(1);
}

#
#  /etc/sysconfig/network-scripts/ifcfg-***ɤ߹ 
#     ߤIPɥ쥹 (eth 0-2,vad)
#     vadե뤬¸ߤboot=yes/noǧ
#     eth0(ޤvad)loΥɥ쥹Ǥʤäϰ۾ｪλ 
#

# ifcfg-eth*ɤ߹
for ($i = 0; $i < 3; $i++){
        if (-f "${ifcfg_dir}\/ifcfg-eth${i}") {
		if(!&configReadFile("${ifcfg_dir}\/ifcfg-eth${i}","ifcfg-eth${i}",*line_tmp)){
			exit(1);
		}

		for(@line_tmp) {
                	if (/^IPADDR\s*=\s*(\S+)\b/) {
                       		# 㡧IPADDR=192.168.2.28
				$ipaddr[$i] = $1;
                       		last;
                        }
                }
		@line_tmp = ();
        }
}

# ifcfg-vadɤ߹
if (-f "${ifcfg_dir}\/ifcfg-vad") {
	if(!&configReadFile("${ifcfg_dir}\/ifcfg-vad","ifcfg-vad",*line_tmp)){
		exit(1);
	}

        for(@line_tmp) {
                if (/^IPADDR\s*=\s*(\S+)\b/) {
			# 㡧IPADDR=192.168.2.28
                	$ipaddr_vad = $1;
                } else {
			if(/^ONBOOT\s*=\s*(\S+)\b/){
				# 㡧ONBOOT=yes
				$vad_flag = $1;
			}
		}
        }
}
@line_tmp = ();

# ifcfg-loɤ߹ ɬܤʤΤǥե¸ߥåɬפʤ
if(!&configReadFile("${ifcfg_dir}\/ifcfg-lo","ifcfg-lo",*line_tmp)){
	exit(1);
}

for(@line_tmp) {
	if (/^IPADDR\s*=\s*(\S+)\b/) {
		# 㡧IPADDR=127.0.0.1
		$ipaddr_lo = $1;
	}
}
@line_tmp = ();

# IPɥ쥹˼Ǥå
if ((($ipaddr[0] eq "") && ($ipaddr_vad eq "")) || ($ipaddr_lo eq "")){
	$err = "IPɥ쥹ǤޤǤ\n";
	print $err;
	exit(1);
} 

#
# FQDN
#
$hostname = getFqdn();
if ($hostname eq ""){
        exit(1);
}

# ۥ̾
@line_tmp = split(/\./, $hostname);
$shorthostname = $line_tmp[0];

@line_tmp = ();

#
#  hostsեκ
#
push(@file1,"${ipaddr_lo}\tlocalhost.localdomain\tlocalhost\n");

if($vad_flag eq "yes"){
	push(@file1,"${ipaddr_vad}\t${hostname}\t${shorthostname}\n");
} else {
	push(@file1,"${ipaddr[0]}\t${hostname}\t${shorthostname}\n");
}

if($ipaddr[1] ne ""){
	push(@file1,"${ipaddr[1]}\t${hostname}\t${shorthostname}\n");
}

if($ipaddr[2] ne ""){
        push(@file1,"${ipaddr[2]}\t${hostname}\t${shorthostname}\n");
}

# hostsեθ
# 桼ɲäԤθФȥԡ
for (@line1) {	
	if ( /$hostname/ ||  /$ipaddr_lo/ || /$ipaddr[0]/) {
		;	# FQDNeth0IPɥ쥹ҤƤԡhostsˤϥԡʤ
	}elsif(($ipaddr_vad ne "") && (/$ipaddr_vad/)){
                ;       # vadIPɥ쥹ҤƤԡhostsˤϥԡʤ
	}elsif(($ipaddr[1] ne "") && /$ipaddr[1]/){
		;	# eth1IPɥ쥹ҤƤԡhostsˤϥԡʤ
	}elsif(($ipaddr[2] ne "")	&& /$ipaddr[2]/){
                ;       # eth2IPɥ쥹ҤƤԡhostsˤϥԡʤ
	}elsif( /^\d+\.\d+\.\d+\.\d+\.\d+\.\d+\.\d+/){
		;	# ԶˤʹԤǤпhostsˤϥԡʤ
			# IPɥ쥹IPɥ쥹ʥꥢˤĤʤäƤ
	}elsif( /^\d+\.\d+\.\d+\.\d+\b/){
		# ԶˤIPɥ쥹FQDNäĤʹԤǤϤʤȤǧ롣
		# IPɥ쥹θ夬ñζˤʤäƤ롣
		# hostsˤ⥳ԡ
		push(@file1,$_);	
	} 
	# 嵭ξŬ礷ʤԤɲäʤ
	
}

# ȹԤɲ
push(@file1,"# Do not remove the following line, or various program\n");
push(@file1,"# that require network functionality will fail.\n");

#
# hostsե񤭹߽
#

if (!&writeFile($hosts_filename, "hosts",@file1)) {
        $err = "$hosts_filenameν񤭹ߤ˼Ԥޤ\n";
        print $err;
	exit(1);
}

exit(0); #ｪλ
