#!/usr/bin/perl

# Copyright (C) 2003 NEC Corporation
# All Rights Reserved.

require "../../../lib/wbmc.pl";

#
# 
$IPLB4_CONF = "/etc/ha4.d/iplb4.conf";
$CONTENTS_CONF = "/etc/iplb_contents/contents.conf";
$NEXT_CGI = "./lbset.cgi";

#
# /etc/ha4.d/iplb4.confեʲξ
# udpport <--- ɥХ󥵡ѥݡֹ
# udp <--- ʬžݡ
if (!&readFile($IPLB4_CONF, "iplb4.conf", *line)) {
	&showErrorPage("iplb4.confեɤ߹ߤ˼Ԥޤ");
	exit(1);
}

my $lb_port = 0;
my $contents_port = 0;
my $load_ether = "";

$LAN1_ON = "";
$LAN3_ON = "";
$DISABLE_ON = "";
$hidden_data = "";
$serial_on = 0;
$udpback_on = 0;
$vad_on = 0;

for ($i = 0; $i < @line ; $i++) {

	if($line[$i] =~ /^#/) {
		next;
	}

	$line[$i] =~ s/\t/ /g;
	@temp = split(/\s+/, $line[$i]);

	if($temp[0] eq "udpport") {
		$lb_port = $temp[1];
	} elsif($temp[0] eq "udp") {
		$load_ether = $temp[1];
		if($load_ether =~ /0/) {
			$LAN1_ON = "CHECKED";
		} elsif($load_ether =~ /1/) {
			$LAN3_ON = "CHECKED";
		} elsif($load_ether eq "vad") {
			$LAN1_ON = "CHECKED";
			$vad_on = 1;
			$DISABLE_ON = "disabled";
			$hidden_data = "<INPUT TYPE=\"hidden\" NAME=\"VAD_ON\" VALUE=\"VAD_ON\">";
		}
	} elsif($temp[0] eq "serial") {
		$serial_on = 1;
	} elsif($temp[0] eq "udpback") {
		$udpback_on = 1;
	} elsif($temp[0] eq "nodetype") {
		if($temp[1] =~ /coor/) {
			$COOR_CHECK = "CHECKED";
		} elsif($temp[1] =~ /backup/) {
			$BACK_CHECK = "CHECKED";
		}
	}
}

if(($serial_on == 1) && ($udpback_on == 1)) {
	if($vad_on == 0) {
		$DOUBLE_LAN_RS = "CHECKED";
	} else {
		$DOUBLE_NO = "CHECKED";
	}
} elsif($serial_on == 1) {
	$DOUBLE_RS232C = "CHECKED";
} elsif($udpback_on == 1) {
	if($vad_on == 0) {
		$DOUBLE_2NDLAN = "CHECKED";
	} else {
		$DOUBLE_NO = "CHECKED";
	}
} else {
	$DOUBLE_NO = "CHECKED";
}

#
# /etc/iplb_contents/contents.conf
# udpport <-- ƥĥǥХ굡ǽΥݡֹ
if (!&readFile($CONTENTS_CONF, "contents.conf", *line)) {
	&showErrorPage("contents.confեɤ߹ߤ˼Ԥޤ");
	exit(1);
}

for ($i = 0; $i < @line ; $i++) {

	if($line[$i] =~ /^#/) {
		next;
	}

	$line[$i] =~ s/\t/ /g;
	@temp = split(/\s+/, $line[$i]);

	if($temp[0] eq "udpport") {
		$contents_port = $temp[1];
	}
}

$navibar = &getNavigation(
    "ƥ","../system.cgi",
    "LB","",
    "_back","../system.cgi",
    "_help","index_help.html"
    );

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>LB</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function func() {
	lb_port = document.FORM_SET.LB_PORT.value;
	cb_port = document.FORM_SET.CB_PORT.value;

	rtn = isNaN(lb_port);
	if(rtn == true) {
		alert("LoadBalancerݡȤˤϿͤꤷƲ");
		return(false);
	}

	rtn = isNaN(cb_port);
	if(rtn == true) {
		alert("ƥĥǥХ굡ǽݡȤˤϿͤꤷƲ");
		return(false);
	}

	if(lb_port < 1 || lb_port > 65535) {
		alert("LoadBalancerݡȤ165535ϰϤǻꤷƲ");
		return(false);
	}

	if(cb_port < 1 || cb_port > 65535) {
		alert("ƥĥǥХ굡ǽݡȤ165535ϰϤǻꤷƲ");
		return(false);
	}

	if(window.confirm("LB¹Ԥޤ\\nƥκƵư˴ؤåɽޤ顢å˽Ƶư¹ԤƤ\\nǤ")) {
		document.FORM_SET.submit();
	}
	return(false);
}
// -->
</SCRIPT>
</HEAD>
<BODY>

<H4 ALIGN=center>LB</H4>
<HR>
$navibar
<HR>

<CENTER>
<FORM NAME="FORM_SET" METHOD="POST" ACTION="$NEXT_CGI">
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1>
 <TR BGCOLOR="#000080">
  <TD colSpan=2><FONT COLOR="#FFFFFF"> <B>ץ̿ݡ</B></FONT></TD>
 </TR>
 <TR ALIGN="center">
   <TD>
   <TABLE BORDER=1 WIDTH=100% CELLSPACING=0 CELLPADDING=1>
        <TR>
         <TD NOWRAP ALIGN="right" WIDTH=70%><B>LoadBalancer</B></TD>
         <TD><INPUT TYPE="text" NAME="LB_PORT" MAXLENGTH=5 SIZE=7 VALUE=$lb_port></TD>
        </TR>
        <TR>
         <TD NOWRAP ALIGN="right"><B>ƥĥǥХ굡ǽ</B></TD>
         <TD><INPUT TYPE="text" NAME="CB_PORT" MAXLENGTH=5 SIZE=7 VALUE="$contents_port"></TD>
        </TR>
  </TABLE>
  </TD>
 </TR>
 <TR BGCOLOR="#000080">
   <TD><FONT COLOR="#FFFFFF"> <B>С</B></FONT></TD>
 </TR>
 <TR ALIGN="center">
  <TD>
   <TABLE>
      <TR>
         <TD NOWRAP><INPUT TYPE="radio" NAME="SERVER_KIND" VALUE="SERV_COOR" $COOR_CHECK>
         ǥ͡</TD>
      </TR>
      <TR>
         <TD NOWRAP><INPUT TYPE="radio" NAME="SERVER_KIND" VALUE="SERV_BACK" $BACK_CHECK>
         Хååץǥ͡</TD>
      </TR>
  </TABLE>
  </TD>
 </TR>
 <TR BGCOLOR="#000080">
   <TD><FONT COLOR="#FFFFFF"> <B>ƻĹǥХ</B></FONT></TD>
 </TR>
 <TR ALIGN="center">
  <TD>
   <TABLE>
        <TR>
         <TD NOWRAP>
          <INPUT TYPE="radio" NAME="CLUSTER_KIND" VALUE="CLUS_NOTUSED" $DOUBLE_NO>ŲʤޤŲ뤬ĹϻѤʤ</TD>
        </TR>
        <TR>
         <TD NOWRAP>
          <INPUT TYPE="radio" NAME="CLUSTER_KIND" VALUE="CLUS_LAN2" $DOUBLE_2NDLAN $DISABLE_ON>
          LANݡ2(ɸ)Ѥ</TD>    <!-- LB300c ɲ -->
<!-- LB300c           2ܤLANѤ</TD>    -->
        </TR>
        <TR>
         <TD NOWRAP>
          <INPUT TYPE="radio" NAME="CLUSTER_KIND" VALUE="CLUS_COM" $DOUBLE_RS232C>
          RS-232CѤ</TD>
        </TR>
        <TR>
         <TD NOWRAP>
          <INPUT TYPE="radio" NAME="CLUSTER_KIND" VALUE="CLUS_LAN2COM" $DOUBLE_LAN_RS $DISABLE_ON>
          LANݡ2(ɸ)RS-232CξѤ</TD>   <!-- LB300c ɲ  -->
<!-- LB300c           2ܤLANRS-232CξѤ</TD>  -->
        </TR>
  </TABLE>
  </TD>
 </TR>
 <TR BGCOLOR="#000080">
   <TD><FONT COLOR="#FFFFFF"> <B>ʬžݡ</B></FONT></TD>
 </TR>
 <TR ALIGN="center">
  <TD>
   <TABLE>
     <TR>
       <TD NOWRAP>
<!-- LB300c          <INPUT TYPE="radio" NAME="TRANS_PORT" VALUE="TRANS_LAN1" $LAN1_ON $DISABLE_ON>1ܤLAN(100M)  -->
         <INPUT TYPE="radio" NAME="TRANS_PORT" VALUE="TRANS_LAN1" $LAN1_ON $DISABLE_ON>LANݡ1(ɸ)
       </TD>
     </TR>
     <TR>
       <TD NOWRAP>
<!-- LB300c          <INPUT TYPE="radio" NAME="TRANS_PORT" VALUE="TRANS_LAN3" $LAN3_ON $DISABLE_ON>3ܤLAN(1000M)  -->
         <INPUT TYPE="radio" NAME="TRANS_PORT" VALUE="TRANS_LAN3" $LAN3_ON $DISABLE_ON>ץLANݡ
       </TD>
     </TR>
     $hidden_data
   </TABLE>
  </TD>
 </TR>

 <TR ALIGN="center">
   <TD><INPUT TYPE="button" VALUE="" onClick="func()">
   </TD>
 </TR>
</TABLE>
</FORM>
</CENTER>

$WBMC_COPYRIGHT

</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

