#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# 060402 LB300dܤNECOбǽ maruo
# ƳΥ顼кȡiplb4.confβȾʬʤʤб

sub writeIPLBServerType
{
    my($ret);
    my($filename);
    my($err) = "";

    $ret = 0;

    $ha4_cf   = "/etc/ha4.d/iplb4.conf";
    $ha4c_cf  = "/etc/ha4.d/iplb4c.conf";
    $ha4b_cf  = "/etc/ha4.d/iplb4b.conf";

#
# Coodinator check
#
  if( defined($IPLB{'IplbType'}) ) {
    if($IPLB{'IplbType'} =~ /Coor/i) {
       if(!&ha_symlink($ha4_cf, $ha4c_cf)) {
          &errorMsg("IPLB:Failure Coordinator setting.");
          goto done;
       }
     }
  }

#
# Backup check
#
 if( defined($IPLB{'IplbType'}) ) {
   if($IPLB{'IplbType'} =~ /Back/i) {
      if(!&ha_symlink($ha4_cf, $ha4b_cf)) {
          &errorMsg("IPLB:Failure Backup setting.");
          goto done;
      }
    }
 }

# 2006/04/02 Modify Start by maruo -------------------------
#Ƴｪλ˵Ͽ̵̤ʥ顼å
#ƳѥǥˤIplbDoubleNULLˤʤѥ
#  ¸ߤ롣Τᡢiplb4.confȾʬν񤭹ߤˤơǥե
#  ȤưŲʤҤ򤹤褦˽IplbDoubleͤ
#  2ndLANεꤵ줿ѥ᡼ƤϤޤʤϥǥե
#  ư򤹤롣

#
# LB Double check
#
   if($IPLB{'IplbDouble'} =~ /2NDLAN/i) {
     if(!&Secand_LAN_On()) {
        &errorMsg("IPLB:Failure iplb4.conf 2ndLAN setting.");
        goto done;
     }
   }
   elsif($IPLB{'IplbDouble'} =~ /RS232C/i) {
     if(!&Rs232c_On()) {
        &errorMsg("IPLB:Failure iplb4.conf RS-232C setting.");
        goto done;
     }
   }
   elsif($IPLB{'IplbDouble'} =~ /LAN-RS/i) {
     if(!&Secand_Rs_On()) {
        &errorMsg("IPLB:Failure iplb4.conf 2ndLAN & RS-232C setting.");
        goto done;
     }
   }
   else{
     if(!&Double_No()) {
        &errorMsg("IPLB:Failure iplb4.conf setting.");
        goto done;
     }
   }
# 2006/04/02 Modify End by maruo -------------------------

$ret = 1;
done:
    return($ret);
}


sub ha_symlink
{
  local($link, $file) = @_;

  my($ret);

  $ret = 0;
  
#
# Symbolic Link support system ?
#
  $symlink_exists = (eval 'symlink("", "");', $@ eq '');
  if ($symlink_exists == 0) {
     #symbolic link not suport system.
     #&errorMsg("IPLB:symbolic link not suport system.");
     goto done;
  }

#
# File check
#
  if (-e $file) {
    if (-e $link && -l $link) {
       unlink($link);
    }
#    symlink($file, $link);
    system( "cp $file $link");
  } else {
     #&errorMsg("IPLB:$file nothing.");
     goto done;
  }

  $ret = 1;

done:
    return($ret);
}

#
# Double Device Select
#
sub Double_No
{
  my($ret);
  my($ha4_2nd_cf) = "";
  my($ha4_cf) = "";

  $ha4_2nd_cf   = "/etc/ha4.d/iplb4-none.conf";
  $ha4_cf   = "/etc/ha4.d/iplb4.conf";
  
  $ret = 0;

  system("cat $ha4_2nd_cf >> $ha4_cf");

  $ret = 1;

done:
    return($ret);
}

sub Secand_LAN_On
{
  my($ret);
  my($ha4_2nd_cf) = "";
  my($ha4_cf) = "";

  $ha4_2nd_cf   = "/etc/ha4.d/iplb4-2nd.conf";
  $ha4_cf   = "/etc/ha4.d/iplb4.conf";

  $ret = 0;

  system("cat $ha4_2nd_cf >> $ha4_cf");

  $ret = 1;

done:
    return($ret);
}

sub Rs232c_On
{
  my($ret);
  my($ha4_2nd_cf) = "";
  my($ha4_cf) = "";

  $ha4_2nd_cf   = "/etc/ha4.d/iplb4-rs.conf";
  $ha4_cf   = "/etc/ha4.d/iplb4.conf";

  $ret = 0;

  system("cat $ha4_2nd_cf >> $ha4_cf");

  $ret = 1;

done:
    return($ret);
}

sub Secand_Rs_On
{
  my($ret);
  my($ha4_2nd_cf) = "";
  my($ha4_cf) = "";

  $ha4_2nd_cf   = "/etc/ha4.d/iplb4-rs2nd.conf";
  $ha4_cf   = "/etc/ha4.d/iplb4.conf";

  $ret = 0;

  system("cat $ha4_2nd_cf >> $ha4_cf");

  $ret = 1;

done:
    return($ret);
}

1;
