#!/bin/sh
#
# Express5800/LB 
#
# Copyright(C) 2003 NEC Corporation.
#

LOGDIR=/opt/nec/wbmc/adm/uloadbalancer/lb4-ud
LOGFILE=/opt/nec/wbmc/adm/uloadbalancer/lb4-ud/lb4-ud.txt

/bin/rm -fr $LOGDIR >/dev/null 2>&1

/bin/mkdir $LOGDIR >/dev/null 2>&1

/bin/date >>$LOGFILE
/bin/uname -a >>$LOGFILE 

echo "=== process info ===" >> $LOGFILE
/bin/ps -auxw >> $LOGFILE
echo "===== ifconfig =====" >> $LOGFILE
/sbin/ifconfig >> $LOGFILE
echo "===== ipvsadm 1 =====" >> $LOGFILE
/sbin/ipvsadm -Ln >> $LOGFILE
echo "===== ipvsadm 2 =====" >> $LOGFILE
/sbin/ipvsadm -Lnc >> $LOGFILE
echo "===== tcpvsadm 1 =====" >> $LOGFILE
/sbin/tcpvsadm -Ln >> $LOGFILE
echo "===== netstat =====" >> $LOGFILE
/bin/netstat -an >> $LOGFILE
echo "===== routing =====" >> $LOGFILE
/bin/netstat -nr >> $LOGFILE
echo "===== iplb file list =====" >> $LOGFILE
ls -la /usr/lib/iplb4 >> $LOGFILE
echo "===== contents file list =====" >> $LOGFILE
ls -la /usr/lib/iplb_contents >> $LOGFILE

/bin/tar -cf $LOGDIR/lb4-ud.tar $LOGFILE >/dev/null 2>&1
/bin/tar -rf $LOGDIR/lb4-ud.tar /opt/nec/wbmc/adm/uloadbalancer/status/ >/dev/null 2>&1
/bin/tar -rf $LOGDIR/lb4-ud.tar /etc/ha4.d/ >/dev/null 2>&1
/bin/tar -rf $LOGDIR/lb4-ud.tar /etc/iplb4.d/ >/dev/null 2>&1
/bin/tar -rf $LOGDIR/lb4-ud.tar /etc/iplb_contents/ >/dev/null 2>&1
#/bin/tar -rf $LOGDIR/lb4-ud.tar /var/log/messages* >/dev/null 2>&1
#/bin/tar -rf $LOGDIR/lb4-ud.tar /var/log/iplb4/ >/dev/null 2>&1
#/bin/tar -rf $LOGDIR/lb4-ud.tar /var/log/iplb_contents/ >/dev/null 2>&1
/bin/tar -rf $LOGDIR/lb4-ud.tar /var/log/ >/dev/null 2>&1
/bin/rm $LOGFILE >/dev/null 2>&1
/bin/gzip $LOGDIR/lb4-ud.tar >/dev/null 2>&1
/bin/mv $LOGDIR/lb4-ud.tar.gz $LOGDIR/lb4-ud.zip

